//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Fri Jan 23 00:04:51 GMT-0800 1998
// Last Modified: Fri Jan 23 00:04:58 GMT-0800 1998
// Filename:      ...sig/code/control/MidiInPort/unsupported/MidiInPort_unsupported.h
// Syntax:        C++ 
// $Smake:        cc -g -c %b.cpp -I../../../../include && rm -f %b.o
//

#ifndef _MIDIINPUT_UNSUPPORTED_H_INCLUDED
#define _MIDIINPUT_UNSUPPORTED_H_INCLUDED

#include "MidiMessage.h"
#include "CircularBuffer.h"
#include "sigTypes.h"

class MidiInPort_unsupported {
   public:
                      MidiInPort_unsupported     (void);
                      MidiInPort_unsupported     (int aPort, int autoOpen = 1);
                     ~MidiInPort_unsupported     ();

      void            close                      (void);
      void            closeAll                   (void);
      MidiMessage     extract                    (void);
      int             getCount                   (void) const;
      const char*     getName                    (void) const;
      int             getNumPorts                (void) const;
      int             getPort                    (void) const;
      int             getPortStatus              (void) const;
      int             getTrace                   (void) const;
      void            insert                     (const MidiMessage& aMessage);
      MidiMessage&    message                    (int index);
      int             open                       (void);
      void            pause                      (void);
      void            setBufferSize              (int aSize);
      void            setPort                    (int aPort);
      int             setTrace                   (int aState);
      void            toggleTrace                (void);
      void            unpause                    (void);

   protected:
      int    port;     // the port to which this object belongs
      int    trace;
 
      static int        objectCount;     // num of similar objects in existence
      static int*       portObjectCount; // objects connected to particular port
      static int*       openQ;           // for open/close status of port
      static int        numDevices;      // number of input ports
      static CircularBuffer<MidiMessage>* midiBuffer; // MIDI storage from ports

   private:
      void            deinitialize               (void); 
      void            initialize                 (void); 
      void            setPortStatus              (int aStatus);
};



#endif  // _MIDIINPUT_UNSUPPORTED_H_INCLUDED



